
z(3)=epsilon;
z(2)=1;
z(1)=Kb;

[fder]=derivative(z,'func',ap,sigmaa,alpha,delta);

er(1)=fder(2,1)/f11;
er(2)=fder(2,3)/f13;
er(3)=fder(3,1)/f21;
er(4)=fder(3,2)/f22;
er(5)=fder(3,3)/f23;
er(6)=fder(1,1)/f1;
er(7)=fder(1,3)/f3;

if max(abs(er-1)) > 4e-5
    error('fatal (checkneoclassical) production function derivatives not accurate')
end


z(1)=Kb;
z(2)=Kb;
z(3)=Kb;
z(4)=epsilon;
z(5)=epsilon;

[eul] = eulersmall(z,alpha,epsilon,ap,sigmaa,delta,gamma,beta);

if max(abs(eul)) > .6e-10
    error('fatal (neoclassical) steady state wrong')
end

[QQ]=derivative(z,'eulersmall',alpha,epsilon,ap,sigmaa,delta,gamma,beta);

for ii=1:length(QQ)
    der(ii)=QQ(ii)*z(ii);
end

der=der/der(1);

derhat=[1 -phi (1/beta) beta_0 beta_1];

if max(abs(der./derhat-1)) > 4e-5
    error('fatal (checkneoclassical) linearized intertemporal euler equation not accurate')
end

err(1)=(1/beta)-phi*A+A^2;
err(2)=-phi*B+A*B+B*rho+beta_0*rho+beta_1;

if max(abs(err)) > .1e-8
    error('fatal (checkneoclassical) something wrong with undetermined coefficients solution')
end