function [u] = getu(alpha,epsilon,ap,sigmaa,kp)

options = optimset('TolFun',1e-12,'TolX',1e-12,'MaxFun',2000,'Diagnostics','off','MaxFunEvals',2000);

[x,fval,exitflag] = fzero('findu',[0.001 10],options,alpha,epsilon,ap,sigmaa,kp);

if exitflag == 0
    error('fatal(getu) maximum number of function evaluations reached')
elseif exitflag < 0
    error('fatal(getu) did not converge to a solution')
end

if isnan(fval) == 1 | abs(imag(fval)) > .1e-0
    error('fatal (getu) optimized function value not a sensible number')
end

u=x;