function [u] = getuunit(alpha,epsilon,ap,sigmaa,kp)

u1=.000001;
u2=400;
[ff1] = finduunit(u1,alpha,epsilon,ap,sigmaa,kp);
[ff2] = finduunit(u2,alpha,epsilon,ap,sigmaa,kp);
if ff1*ff2 > 0
    error('fatal (getuunit) solution not bracketted')
end

options = optimset('TolFun',1e-12,'TolX',1e-12,'MaxFun',2000,'Diagnostics','off','MaxFunEvals',2000);

[x,fval,exitflag] = fzero('finduunit',[u1 u2],options,alpha,epsilon,ap,sigmaa,kp);

if abs(fval) > .1e-8
    error('fatal (getuunit) failed to solve for utilization')
end

if exitflag == 0
    error('fatal(getuunit) maximum number of function evaluations reached')
elseif exitflag < 0
    error('fatal(getuunit) did not converge to a solution')
end

if isnan(fval) == 1 | abs(imag(fval)) > .1e-0
    error('fatal (getuunit) optimized function value not a sensible number')
end

u=x;