%This is software that goes with the tutorial on model solutions
clear
close all

%setting the model parameter values....
beta=1.03^(-.25);
alpha=.36;
delta=.02;
rho=0.95;
rho=.99;
epsilon=1;
sigma=1;
sigma_a=.1;

%replace lines 18 and 19 with formulas for the steady state stock of capital and the parameter of the
%adjustment cost function, b (question 5)....

k=[];
b=[];

%replace the following line with the formulas for the log-linearly expanded
%euler equation for capital utilization...

deruu=[];

%now, compute the log-linear expansion numerically. for this, you have to enter the formula for the equation
%being expanded into Vu.m.
x(1)=k;
x(2)=1;
x(3)=epsilon;
[vu] = Vu(x,sigma_a,alpha,b);

%the following is a check that vu is actually zero!
if abs(vu) > .1e-9
    error('fatal (hmk1) static euler equation not satisfied')
end

%now, compute the derivative of Vu
[QQ]=derivative(x,'Vu',sigma_a,alpha,b);


%don't forget to adjust the derivative for the fact that this is a
%log-linear expansion....not a linear expansion!
deru=QQ.*x;

%compute the ratio of the two types of derivatives...
rat=deruu./deru;

if (abs(rat-1)) > .0000001
    error('fatal (hmk1answer) derivatives not accurate')
end

%now, compute the log-linear expansion of the intertemporal euler equation,
%numerically. you have to enter the equation to be differentiated in the
%appropriate place in Vk...
y(1)=k;
y(2)=k;
y(3)=k;
y(4)=1;
y(5)=1;
y(6)=epsilon;
y(7)=epsilon;

[eul] = Vk(y,sigma_a,alpha,b,delta,sigma,beta);

%verify that the euler equation is zero at steady state...
if abs(eul) > .1e-9
    error('fatal (hmk1) dynamic euler equation not satisfied')
end

%compute the numerical derivative of the intertemporal euler equation..
[QQ]=derivative(y,'Vk',sigma_a,alpha,b,delta,sigma,beta);
%adjust for log-linear expansion...
derk=QQ.*y;

%replace the following lines with the correct formulas....

alpha_2=[];
alpha_1=[];
alpha_0=[];
beta_0=[];
beta_1=[];

%enter the formula for A and B

A=[];
B=[];

speed=log(0.10)/log(A);%this is the time needed to close 90 of the gap, in the time units of the model

Ik=(A-(1-delta))/delta;
Ieps=B/delta;
Yk=alpha;
Yeps=1;
C=epsilon*(k^alpha)-delta*k;
Ceps=(epsilon*k^alpha-k*B)/C;
Ck=(alpha*epsilon*k^alpha-k*A+(1-delta)*k)/C;
uk=-deru(1)/deru(2);
ueps=-deru(3)/deru(2);
Y=epsilon*(k^alpha);

%type in formulas here, to verify the 
%consistency of Yk, Ck, Ik and of Yeps, Ceps, Ieps.


eps=zeros(T,1);
eps(1)=.01;
z(1)=B*eps(1);%z(t) corresponds to k(t+1)
cons(1)=Ceps*eps(1);
inv(1)=Ieps*eps(1);
util(1)=ueps*eps(1);
gnp(1)=Yeps*eps(1);

for ii = 2:T

    eps(ii)=rho*eps(ii-1)+eps(ii);
    z(ii)=A*z(ii-1)+B*eps(ii);
    cons(ii)=Ck*z(ii-1)+Ceps*eps(ii);
    inv(ii)=Ik*z(ii-1)+Ieps*eps(ii);
    util(ii)=uk*z(ii-1)+ueps*eps(ii);
    gnp(ii)=Yk*z(ii-1)+Yeps*eps(ii);

end